// Copyright (c) 2012-2021 Wojciech Figat. All rights reserved.

using System.IO;
using Flax.Build;
using Flax.Build.NativeCpp;

/// <summary>
/// https://github.com/microsoft/UVAtlas
/// </summary>
public class UVAtlas : DepsModule
{
    /// <inheritdoc />
    public override void Init()
    {
        base.Init();

        LicenseType = LicenseTypes.MIT;
        LicenseFilePath = "LICENSE";
    }

    /// <inheritdoc />
    public override void Setup(BuildOptions options)
    {
        base.Setup(options);

        var depsRoot = options.DepsFolder;
        switch (options.Platform.Target)
        {
        case TargetPlatform.Windows:
            options.OutputFiles.Add(Path.Combine(depsRoot, "UVAtlas.lib"));
            options.OptionalDependencyFiles.Add(Path.Combine(depsRoot, "UVAtlas.pdb"));
            break;
        default: throw new InvalidPlatformException(options.Platform.Target);
        }
    }
}
